VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Session"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Ch6b.cls
' Copyright 2001 Matthew J. Holmes
'
Option Explicit

Private Const c_strReturn As String = "RETURN_VALUE"
Private Const c_strConnect As String = _
    "Provider=sqloledb;Data Source=IO;Initial Catalog=Ch6b;User Id=sa;Password=...;"

Private m_DeviceID As String

' Create()
'
' Creates a new session (deletes any expired session) for the current user/device.
' Returns 0 for ok, 1 for bad user, 2 for bad password, 3 for bad device, 4 for in use
'
Public Function Create(Uid As Variant, Pwd As Variant, DID As Variant) As Long

    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_CreateSession(?, ?, ?)}"
        .Parameters.Refresh
        .Parameters("@Name") = Uid
        .Parameters("@Password") = Pwd
        .Parameters("@Device") = DID
        .Execute
    End With
    
    m_DeviceID = DID
    Create = SqlProc(c_strReturn)

End Function

' Attach()
'
' Finds current session.
' Returns 0 for ok, 1 for bad device, 2 for no session
'
Public Function Attach(DID As Variant) As Long

    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_AttachSession(?)}"
        .Parameters.Refresh
        .Parameters("@Device") = DID
        .Execute
    End With
    
    m_DeviceID = DID
    Attach = SqlProc(c_strReturn)
    
End Function

' Drop()
'
' Removes current session.
' Returns 0 for ok, 1 for bad device, 2 for no session
'
Public Function Drop(DID As Variant) As Long

    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_DropSession(?)}"
        .Parameters.Refresh
        .Parameters("@Device") = DID
        .Execute
    End With
    
    m_DeviceID = ""
    Drop = SqlProc(c_strReturn)

End Function

' Manager()
'
' Runs stored procedure and returns 1 if a manager, 0 otherwise
'
Public Function Manager() As Long

    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_Manager(?)}"
        .Parameters.Refresh
        .Parameters("@Device") = m_DeviceID
        .Execute
    End With
    
    Manager = SqlProc(c_strReturn)
    
End Function

' GetJobList()
'
' Finds current job list for this session/user.
' Returns 0 for OK, 1 for bad device
'
Public Function GetJobList(ByRef Data As Variant) As Long
    
    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_GetJobList(?)}"
        .Parameters.Refresh
        .Parameters("@Device") = m_DeviceID
        .Execute
    End With
    
    ' Hook up the disconnected recordset to the results
    Set Data = New ADOR.Recordset
    With Data
        .CursorLocation = adUseClient
        .CursorType = adOpenStatic
        .Open SqlProc
    End With
    
    GetJobList = SqlProc(c_strReturn)
   
End Function

' GetJobDetails()
'
' Finds requested job for this session/user. Always returns 0
'
Public Function GetJobDetail(ByRef JID As Variant, ByRef Data As Variant) As Long
    
    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_GetJobDetail(?)}"
        .Parameters.Refresh
        .Parameters("@JID") = JID
        .Execute
    End With
    
    ' Hook up the disconnected recordset to the results
    Set Data = New ADOR.Recordset
    With Data
        .CursorLocation = adUseClient
        .CursorType = adOpenStatic
        .Open SqlProc
    End With
    
    GetJobDetail = SqlProc(c_strReturn)
   
End Function

' ChangeJob
'
Public Function ChangeJob(ByRef JID As Variant, ByRef Data As Variant) As Long

    Dim Params As Scripting.Dictionary
    Set Params = Data
    
    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_ChangeJob(?, ?, ?, ?)}"
        .Parameters.Refresh
        .Parameters("@JID") = JID
        .Parameters("@Status") = Params.Item(0)
        .Parameters("@JobTime") = Params.Item(1) & " " & Params.Item(2)
        .Parameters("@Remarks") = Params.Item(3)
        .Execute
    End With
    
   ChangeJob = SqlProc(c_strReturn)

End Function
' GetCustomerList()
'
' Page through the customer list in increments supplied by the
' caller. Return disconnected recordset positioned to proper record.
'
Public Function GetCustomerList(ByVal WhichPage As Variant, ByVal WhatSize As Variant, ByRef Data As Variant) As Long
    
    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_GetCustomerList}"
        .Parameters.Refresh
        .Execute
    End With
    
    ' Hook up the disconnected recordset, set the page size and get the results
    Set Data = New ADOR.Recordset
    With Data
        .PageSize = WhatSize
        .CursorLocation = adUseClient
        .CursorType = adOpenStatic
        .Open SqlProc
    End With

    ' Position to the correct page
    If WhichPage <= Data.PageCount Then
        Data.AbsolutePage = WhichPage
    Else
        Data.AbsolutePage = Data.PageCount
    End If

    GetCustomerList = SqlProc(c_strReturn)
   
End Function

' GetCustomerDetails()
'
' Finds requested info for this session/user. Always returns 0
'
Public Function GetCustomerDetails(ByRef CID As Variant, ByRef Data As Variant) As Long
    
    Dim SqlCn As New ADODB.Connection
    SqlCn.Open c_strConnect
    
    Dim SqlProc As New ADODB.Command
    With SqlProc
        Set .ActiveConnection = SqlCn
        .CommandText = "{?=call Ch6b_GetCustomerDetail(?)}"
        .Parameters.Refresh
        .Parameters("@CID") = CID
        .Execute
    End With
    
    ' Hook up the disconnected recordset to the results
    Set Data = New ADOR.Recordset
    With Data
        .CursorLocation = adUseClient
        .CursorType = adOpenStatic
        .Open SqlProc
    End With
    
    GetCustomerDetails = SqlProc(c_strReturn)
   
End Function
